include asmio16.inc

.data
message 	db "Hello, world!", 0
buffer 	db 256 dup (0)
decerrmes 	db CR,LF,'Decimal error', 0
hexerrmes 	db CR,LF,'Hex error', 0
decint 	dw -23765
mesreadchar 	db CR,LF,'Input char ',0
mesreadstr 	db CR,LF,'Input string ',0
mesreadint 	db CR,LF,'Input decimal number ',0
mesreadhex 	db CR,LF,'Input hexadecimal number ',0

.code

start:
	mov ax, @data
	mov ds, ax

	mov al, 'A'
	call WriteChar	;  
	call Crlf
	lea dx, message
	call WriteString	;  
	call Crlf
	mov al, 0FCh
	call WriteByteHex	;  8- 
	call Crlf
	mov ax, 0A81Eh
	call WriteWordHex	;  16- 
	call Crlf
	mov ax, 45869
	call WriteUnsigned	;   
	call Crlf
	mov ax, decint
	call WriteInt		;   
	lea dx, mesreadchar
	call WriteString
	call ReadChar		;  
	call Crlf
	call WriteChar
	lea dx, mesreadstr
	call WriteString
	lea dx, buffer
	mov cx, 10
	call ReadString	;   
	call Crlf
	lea dx, buffer
	call WriteString
	lea dx, mesreadhex
	call WriteString
	call ReadHex		;   
	jc hexerror
	call Crlf
	call WriteWordHex
	lea dx, mesreadint
	call WriteString
	call ReadInt		;   
	jc decerror
	call Crlf
	call WriteInt
	jmp short quit
hexerror:
	lea dx, hexerrmes
	call WriteString
	jmp short quit
decerror:
	lea dx, decerrmes
	call WriteString
quit:	
	mov ax, 4c00h
	int 21h

end start
